; *******************************************************************
; EDU10 Lesson 9 - Timer 0
;
; Lesson 9 shows how to configure and use the Timer0 peripheral to
; implement the delay function used in earlier lessons.
; *******************************************************************
; * For more details see Microchip's 44-pin Demo Board User's Guide *
; * Chapter 3. 44-Pin Demo Board Lessons                            *
; * http://ww1.microchip.com/downloads/en/DeviceDoc/41296B.pdf      *
; *******************************************************************

#include <p16F887.inc>
	__CONFIG    _CONFIG1, _LVP_OFF & _FCMEN_OFF & _IESO_OFF & _BOR_OFF & _CPD_OFF & _CP_OFF & _MCLRE_ON & _PWRTE_ON & _WDT_OFF & _INTRC_OSC_NOCLKOUT
	__CONFIG    _CONFIG2, _WRT_OFF & _BOR21V

     cblock     0x20
Display
tmp
     endc

     org 0
     bsf       STATUS,RP0     ; Bank 1
     movlw     b'00000111'    ; configure Timer0.  Sourced from the Processor clock;
     movwf     OPTION_REG     ; Maximum Prescaler
	 movlw     B'00001111'
 	 movwf     TRISC          ; Make PORTC RC4-RC7 as outputs
     clrf      Display
     bcf       STATUS,RP0     ; Bank 0
     
ForeverLoop:
     btfss     INTCON,T0IF    ; wait here until Timer0 rolls over
     goto      ForeverLoop
     bcf       INTCON,T0IF    ; flag must be cleared in software
     incf      Display,f      ; increment display variable
     movf      Display,w
     movwf     tmp
     swapf     tmp,w		  ; Swap nibbles
     movwf     PORTC		  ; show on LEDs the low nibble of the counter 'Display' 	
     goto      ForeverLoop
     
     
     end
