; *******************************************************************
; EDU10 Lesson 15 - "Beep"
;
; This lesson demonstrates how to generate a sound.
; The buzzer is connected to the RC0 output port.
; Pressing button SW1 activates the sound generation.
; *******************************************************************


#include <p16F882.inc>
	__CONFIG    _CONFIG1, _LVP_OFF & _FCMEN_OFF & _IESO_OFF & _BOR_OFF & _CPD_OFF & _CP_OFF & _MCLRE_ON & _PWRTE_ON & _WDT_OFF & _INTRC_OSC_NOCLKOUT
	__CONFIG    _CONFIG2, _WRT_OFF & _BOR21V

	cblock     0x20
tmp1
Delay1
Delay2
Delay3
	endc
     
	org 0x00
	goto	Start
	org		0x100
Start:
	bsf     STATUS,RP0       		; select Register Bank 1
	clrf    TRISC               	; Make PORTC all output
	bcf		STATUS,RP0     			; back to Register Bank 0
	clrf	PORTC            		; PORTC LEDs all off

MainLoop:
	btfsc	PORTA,4	
	goto	SW1_pressed
	goto    MainLoop	

SW1_pressed					    ; sound buzzer
    clrf    Delay1
    clrf    Delay2
	movlw	d'20'				; set total tone length
	movwf	Delay3
	movlw	d'60'			
	movwf	tmp1				; set average tone pitch				
loop1
	decfsz	Delay1,f       		; Waste time.  
	goto	loop1    
	movf	PORTC,w				; read 
	xorlw	0x01				; invert buzzer bit
	andlw	0x01
	movwf	PORTC				; sounder to PORTC
	movf	tmp1,w
	movwf	Delay1				
loop2
	decfsz	Delay1,f       		; Waste time.  
	goto	loop2 
	movf	tmp1,w
	movwf	Delay1				
	movf	Delay2,w
	andlw	b'0000000111'		; check if pitch will be changed
	btfss	STATUS,Z
	goto	no_pitch_change		; no pitch change
	btfsc	Delay3,0
	incf	tmp1				; dec pitch
	btfss	Delay3,0
	decf	tmp1				; inc pitch
no_pitch_change
	decfsz  Delay2
	goto	loop1			
	decfsz  Delay3
	goto	loop1
	goto    MainLoop


    end
